-----------------------------
-- INIT
-----------------------------

local addon, ns = ...
local cfg = CreateFrame("Frame")
local mediaFolder = "Interface\\AddOns\\oUF_BfA\\media\\"	-- don't touch this ...

-----------------------------
-- CONFIG
-----------------------------

-- Units
cfg.showtot = true 					-- show target of target frame
cfg.showpet = true 					-- show pet frame
cfg.showfocus = true 				-- show focus frame
cfg.showfocustarget = true 			-- show focus target frame
cfg.ShowPlayerName = true 			-- show player's name and level
cfg.ShowTargetPower = false 		-- show target power
cfg.showBossFrames = true 			-- show boss frame

-- Portraits
-- cfg.portraits = false
cfg.showportraitplayer = true 		-- show player's portrait
cfg.showportraittarget = true 		-- show target's portrait
cfg.showportraitparty = true 		-- show party's portrait
cfg.playerportraitheight = 40
cfg.playerportraitwidth = 50
cfg.targetportraitheight = 40
cfg.targetportraitwidth = 50
cfg.partyportraitheight = 35
cfg.partyportraitwidth = 35

-- Health Frames
cfg.playerhealthframewidth = 275
cfg.playerhealthframeheight = 35
cfg.targethealthframewidth = 275
cfg.targethealthframeheight = 35
cfg.focushealthframewidth = 120
cfg.focushealthframeheight = 35
cfg.tothealthframewidth = 120
cfg.tothealthframeheight = 35
cfg.focustargethealthframewidth = 120
cfg.focustargethealthframeheight = 35
cfg.pethealthframewidth = 120
cfg.pethealthframeheight = 35

-- Raid and Party
cfg.ShowParty = true  				-- show party frames
cfg.ShowSelfParty = true   			-- show self in party
cfg.party_leader_icon = true   		-- Show Leader Icon
cfg.showPartyHorizontal = false 	-- shows party frames horizontally

cfg.ShowRaid = false 				-- show raid frames
cfg.RaidShowSolo = false 			-- show raid frames even when solo

-- Positioning
cfg.PlayerX = -250  				-- Player frame's x-offset position from the relative point of the screen
cfg.PlayerY = -260 					-- Player frame's y-offset position from the relative point of the screen
cfg.PlayerRelativePoint = "CENTER"	-- Player frame's reference point of the screen used for X and Y offsets. Possible values are: "TOP"/"BOTTOM"/"LEFT"/"RIGHT"/"CENTER"/"TOPLEFT"/"ROPRIGHT"/"BOTTOMLEFT"/"BOTTOMRIGHT"
cfg.TargetX = 250 					-- Target frame's x-offset position from the relative point of the screen
cfg.TargetY = -260 					-- Target frame's y-offset position from the relative point of the screen
cfg.TargetRelativePoint = "CENTER"	-- Target frame's reference point of the screen used for X and Y offsets. Possible values are: "TOP"/"BOTTOM"/"LEFT"/"RIGHT"/"CENTER"/"TOPLEFT"/"ROPRIGHT"/"BOTTOMLEFT"/"BOTTOMRIGHT"
cfg.TotX = 0		 				-- Target of target frame's x-offset position from the relative point of the screen
cfg.TotY = 8 						-- Target of target frame's y-offset position from the relative point of the screen
cfg.TotRelativePoint = "TOPRIGHT"	--"RIGHT" -- Target of target frame's reference point of the screen used for X and Y offsets. Possible values are: "TOP"/"BOTTOM"/"LEFT"/"RIGHT"/"CENTER"/"TOPLEFT"/"ROPRIGHT"/"BOTTOMLEFT"/"BOTTOMRIGHT"  
cfg.FocusX = 450				 	-- Focus frame's x-offset position from the relative point of the screen
cfg.FocusY = 50 					-- Focus frame's y-offset position from the relative point of the screen
cfg.FocusRelativePoint = "TOP" 		-- Focus frame's reference point of the screen used for X and Y offsets. Possible values are: "TOP"/"BOTTOM"/"LEFT"/"RIGHT"/"CENTER"/"TOPLEFT"/"ROPRIGHT"/"BOTTOMLEFT"/"BOTTOMRIGHT"  
cfg.PartyX = -1020 					-- Party Frames Horizontal Position
cfg.PartyY = 100 					-- Party Frames Vertical Position
cfg.RaidX = -910 					-- Party Frames Horizontal Position
cfg.RaidY = 550 					-- Party Frames Vertical Position
cfg.BossX = -10 					-- Boss Frames Horizontal Position
cfg.BossY = -230 					-- Boss Frames Vertical Position
cfg.PetX = 0		 				-- Pet frame's x-offset position from the relative point of the screen
cfg.PetY = 8 						-- Pet frame's y-offset position from the relative point of the screen
cfg.PetRelativePoint = "TOPLEFT"	-- Pet frame's reference point of the screen used for X and Y offsets. Possible values are: "TOP"/"BOTTOM"/"LEFT"/"RIGHT"/"CENTER"/"TOPLEFT"/"ROPRIGHT"/"BOTTOMLEFT"/"BOTTOMRIGHT"  



-- Auras
cfg.showPlayerAuras = false 		-- use a custom player buffs/debuffs frame instead of Blizzard's default.
cfg.showTargetBuffs = true 			-- show target buffs
cfg.showTargetDebuffs = true 		-- show target debuffs
cfg.showBossBuffs = true 			-- show target buffs
cfg.showBossDebuffs = true 			-- show target debuffs
cfg.debuffsOnlyShowPlayer = true 	-- only show your debuffs on target
cfg.buffsOnlyShowPlayer = false 	-- only show your buffs

-- Plugins
cfg.enableDebuffHighlight = true 	-- enable *dispelable* debuff highlight for raid frames
cfg.showRaidDebuffs = true 			-- enable important debuff icons to show on raid units

-- Misc
cfg.showRunebar = true 				-- show DK's rune bar
cfg.showClassbar = true 			-- Soul shards, arcane charges, holy power and chi


cfg.RCheckIcon = true 				-- show raid check icon
cfg.Castbars = true 				-- use built-in castbars
cfg.ShowIncHeals = true 			-- Show incoming heals in player and raid frames
cfg.showLFDIcons = true 			-- Show dungeon role icons in raid/party

cfg.statusbar_texture = mediaFolder.."Minimalist"--"Statusbar"
cfg.powerbar_texture = mediaFolder.."Minimalist"
cfg.backdrop_texture = mediaFolder.."backdrop"
cfg.highlight_texture = mediaFolder.."raidbg"
cfg.debuffhighlight_texture = mediaFolder.."debuff_highlight"
cfg.backdrop_edge_texture = mediaFolder.."backdrop_edge"
cfg.debuffBorder = mediaFolder.."iconborder"
cfg.spark = mediaFolder.."spark"
cfg.font = mediaFolder.."Emblem.ttf"--"ROADWAY.ttf"
cfg.smallfont = mediaFolder.."Emblem.ttf"
cfg.raidScale = 0.9 				-- scale factor for raid and party frames
cfg.scale = 0.95 					-- scale factor for all other frames
cfg.fader = 0.4

-----------------------------
-- HANDOVER
-----------------------------

ns.cfg = cfg
